#include "CityModel/impl/CityModelPluginImpl.hpp"

#ifdef NDEBUG
  #define DEBUG_MESSAGE(a) /**/
#else
  #define DEBUG_MESSAGE(a) a
#endif
#include <iostream>

#include "CityModel/CityModelFactory.hpp"
#include "CityModel/CityModelPackage.hpp"

using namespace CityModel;

//*********************************
// Constructor / Destructor
//*********************************
CityModelPluginImpl::CityModelPluginImpl()
{
}

CityModelPluginImpl::~CityModelPluginImpl()
{
}

std::shared_ptr<ecore::EObject> CityModelPluginImpl::create(const std::string& name) const
{		
	return CityModelFactory::eInstance()->create(name);
}

std::shared_ptr<ecore::EObject> CityModelPluginImpl::create(const std::string& name, std::shared_ptr<ecore::EObject> container, const unsigned int referenceID) const
{
	std::cout << "WARNING: container based create function is not implemented for UML models!!!" << std::endl;
	return nullptr; //CityModelFactory::eInstance()->create(name, container, referenceID);
}

std::shared_ptr<uml::Factory> CityModelPluginImpl::getFactory()
{
	return CityModelFactory::eInstance();
}

std::shared_ptr<uml::Package> CityModelPluginImpl::getPackage()
{
	return CityModelPackage::eInstance();
}

std::string CityModelPluginImpl::eclipseURI()
{
	return "";
}

std::string CityModelPluginImpl::eNAME()
{
	return "CityModel";
}

std::string CityModelPluginImpl::eNS_URI()
{
	return "";
}

std::string CityModelPluginImpl::eNS_PREFIX()
{
	return "";
}
