#include "CityModel/impl/PublicBuildingImpl.hpp"

#ifdef NDEBUG
  #define DEBUG_MESSAGE(a) /**/
#else
  #define DEBUG_MESSAGE(a) a
#endif

#include <iostream>

#include "abstractDataTypes/Bag.hpp"

#include "abstractDataTypes/Any.hpp"
#include "abstractDataTypes/SubsetUnion.hpp"
#include "util/util.hpp"
#include "uml/Property.hpp"
#include "uml/Operation.hpp"
#include "uml/Parameter.hpp"
#include "CityModel/CityModelFactory.hpp"
#include "CityModel/impl/CityModelPackageImpl.hpp"
#include "uml/Class.hpp"

//Types included from attributes, operation parameters, imports and composite owner classes
#include "CityModel/Person.hpp"

//Packges and Factories included from types of attributes, operation parameters, imports and composite owner classes

//Packages of included Enumerations

//Includes of PluginFramework (if required)

//Includes of OpaqueBevaiors (if required)
//Included from operation "addEmployee"
#include "CityModel/Person.hpp"
//Included from operation "removeEmployee"
#include "CityModel/Person.hpp"

//Includes from InstanceValues (if required)

//Includes from Ports typed by interfaces (if required)

//Includes from roles of ConnectorEnds (if required)

using namespace CityModel;

//*********************************
// Constructor / Destructor
//*********************************
PublicBuildingImpl::PublicBuildingImpl()
{
	/*
	NOTE: Due to virtual inheritance, base class constrcutors may not be called correctly
	*/
	DEBUG_MESSAGE(std::cout<<"PublicBuilding is created..."<<std::endl;)
	//***********************************
	// init Get Set
	//getter init
		//Property employees
		m_getterMap.insert(std::pair<long long,std::function<Any()>>(879581389,[this](){ return eAny(this->getEmployees());}));
		//Property purpose
		m_getterMap.insert(std::pair<long long,std::function<Any()>>(1661254561,[this](){ return eAny(this->getPurpose());}));
	
	
	//setter init
	//Property purpose
		m_setterMap.insert(std::pair<long long,std::function<void(Any)>>(1661254561,[this](Any object){this->setPurpose(object->get<std::string>());}));
	
	
	//unsetter init
		//Property employees
		m_unsetterMap.insert(std::pair<long long,std::function<void()>>(879581389,[this](){m_employees->clear();}));
	
	
	//invocation init
		//Operation addEmployee
		m_invocationMap.insert(std::pair<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>(235038160, [this](std::shared_ptr<Bag<Any>> arguments) {
			//Retrieve input parameter 'person'
			Any anyPerson = *(arguments->at(0).get());
			std::shared_ptr<CityModel::Person> person = anyPerson->get<std::shared_ptr<CityModel::Person>>();
	
			this->addEmployee(person);
			return eAny(nullptr);
		}));
		//Operation removeEmployee
		m_invocationMap.insert(std::pair<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>(1666729207, [this](std::shared_ptr<Bag<Any>> arguments) {
			//Retrieve input parameter 'person'
			Any anyPerson = *(arguments->at(0).get());
			std::shared_ptr<CityModel::Person> person = anyPerson->get<std::shared_ptr<CityModel::Person>>();
	
			this->removeEmployee(person);
			return eAny(nullptr);
		}));
	
}


PublicBuildingImpl::~PublicBuildingImpl()
{
	DEBUG_MESSAGE(std::cout<<"PublicBuilding is destroyed..."<<std::endl;)
}

PublicBuildingImpl::PublicBuildingImpl(const PublicBuildingImpl & obj):PublicBuildingImpl()
{
	*this = obj;
}

std::shared_ptr<ecore::EObject>  PublicBuildingImpl::copy() const
{
	std::shared_ptr<PublicBuildingImpl> element(new PublicBuildingImpl());
	*element=(*this);
	element->setThisPublicBuildingPtr(element);
	return element;
}

PublicBuildingImpl& PublicBuildingImpl::operator=(const PublicBuildingImpl & obj)
{
	//call overloaded =Operator for each base class
	BuildingImpl::operator=(obj);
	//create copy of all Attributes
	#ifdef SHOW_COPIES
	std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\r\ncopy PublicBuilding "<< this << "\r\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ " << std::endl;
	#endif
	instantiate();

	//copy attributes with no containment (soft copy)
	m_employees = obj.getEmployees();
	m_purpose = obj.getPurpose();

	//clone attributes with containment (deep copy)

	return *this;
}


std::shared_ptr<uml::Class> PublicBuildingImpl::getMetaClass()
{
	return CityModelPackageImpl::eInstance()->get_CityModel_PublicBuilding();
}

void PublicBuildingImpl::instantiate()
{   
	BuildingImpl::instantiate();
	
	
}

void PublicBuildingImpl::destroy()
{	

	//Erase properties
	//deleting property employees
	m_employees->clear();
	
	
	//Erase back reference to owner
}

//*********************************
// Attribute Setter Getter
//*********************************

std::shared_ptr<Bag<CityModel::Person>> PublicBuildingImpl::getEmployees() const 
{
	if(m_employees == nullptr)
	{
		m_employees.reset(new Bag<CityModel::Person>());
		
	}

	return m_employees;
}

void PublicBuildingImpl::setPurpose(std::string _purpose)
{
	m_purpose = _purpose;
	
}
std::string PublicBuildingImpl::getPurpose() const 
{

	return m_purpose;
}

//*********************************
// Union Getter
//*********************************



//*********************************
// Operations
//*********************************
void PublicBuildingImpl::addEmployee(std::shared_ptr<CityModel::Person> person) 
{

	// Implemented as Opaque behaviour addEmployee

m_employees -> add(person);

}

void PublicBuildingImpl::removeEmployee(std::shared_ptr<CityModel::Person> person) 
{

	// Implemented as Opaque behaviour removeEmployee

m_employees -> erase(person);

}

//*********************************
// Structural Feature Getter/Setter
//*********************************
//Get
Any PublicBuildingImpl::get(std::shared_ptr<uml::Property> _property) const
{
	std::string qualifiedName = _property->getQualifiedName();
    return this->get(qualifiedName);
}

Any PublicBuildingImpl::get(std::string _qualifiedName) const
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    return this->get(uID);
}

Any PublicBuildingImpl::get(long long _uID) const
{
	std::map<long long, std::function<Any()>>::const_iterator iter = m_getterMap.find(_uID);
    if(iter != m_getterMap.cend())
    {
        //invoke the getter function
        return iter->second();
    }

	Any result;
	result = CityModel::BuildingImpl::get(_uID);
	if (result != nullptr)
	{
		return result;
	}
	return result;
}

//Set
void PublicBuildingImpl::set(std::shared_ptr<uml::Property> _property, Any value)
{
	std::string qualifiedName = _property->getQualifiedName();
    this->set(qualifiedName, value);
}

void PublicBuildingImpl::set(std::string _qualifiedName, Any value)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    this->set(uID, value);
}

void PublicBuildingImpl::set(long long _uID, Any value)
{
	std::map<long long, std::function<void(Any)>>::const_iterator iter = m_setterMap.find(_uID);
    if(iter != m_setterMap.cend())
    {
        //invoke the setter function
        iter->second(value);
    }
	CityModel::BuildingImpl::set(_uID, value);
}

//Unset
void PublicBuildingImpl::unset(std::shared_ptr<uml::Property> _property)
{
	std::string qualifiedName = _property->getQualifiedName();
    this->unset(qualifiedName);
}

void PublicBuildingImpl::unset(std::string _qualifiedName)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    this->unset(uID);
}

void PublicBuildingImpl::unset(long long _uID)
{
	std::map<long long, std::function<void()>>::const_iterator iter = m_unsetterMap.find(_uID);
    if(iter != m_unsetterMap.cend())
    {
        //invoke the unsetter function
        iter->second();
    }
	CityModel::BuildingImpl::unset(_uID);
}


//*********************************
// Operation Invoction
//*********************************
//Invoke
Any PublicBuildingImpl::invoke(std::shared_ptr<uml::Operation> _operation, std::shared_ptr<Bag<Any>> _arguments)
{
	std::string qualifiedName = _operation->getQualifiedName();

	for(unsigned int i = 0; i < _operation->getOwnedParameter()->size(); i++)
	{
		qualifiedName += "_" + _operation->getOwnedParameter()->at(i)->getType()->getName();
	}

    return this->invoke(qualifiedName, _arguments);
}

Any PublicBuildingImpl::invoke(std::string _qualifiedName, std::shared_ptr<Bag<Any>> _arguments)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    return this->invoke(uID, _arguments);
}

Any PublicBuildingImpl::invoke(long long _uID, std::shared_ptr<Bag<Any>> _arguments)
{
	std::map<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>::const_iterator iter = m_invocationMap.find(_uID);
    if(iter != m_invocationMap.cend())
    {
        //invoke the operation
        return iter->second(_arguments);
    }
	
	Any result;
	result = CityModel::BuildingImpl::invoke(_uID, _arguments);
	if (result != nullptr)
	{
		return result;
	}
	return result;
}

std::shared_ptr<PublicBuilding> PublicBuildingImpl::getThisPublicBuildingPtr()
{
	return m_thisPublicBuildingPtr.lock();
}
void PublicBuildingImpl::setThisPublicBuildingPtr(std::weak_ptr<PublicBuilding> thisPublicBuildingPtr)
{
	m_thisPublicBuildingPtr = thisPublicBuildingPtr;
	setThisBuildingPtr(thisPublicBuildingPtr);
}
