#include "CityModel/impl/ResidentialBuildingImpl.hpp"

#ifdef NDEBUG
  #define DEBUG_MESSAGE(a) /**/
#else
  #define DEBUG_MESSAGE(a) a
#endif

#include <iostream>

#include "abstractDataTypes/Bag.hpp"

#include "abstractDataTypes/Any.hpp"
#include "abstractDataTypes/SubsetUnion.hpp"
#include "util/util.hpp"
#include "uml/Property.hpp"
#include "uml/Operation.hpp"
#include "uml/Parameter.hpp"
#include "CityModel/CityModelFactory.hpp"
#include "CityModel/impl/CityModelPackageImpl.hpp"
#include "uml/Class.hpp"

//Types included from attributes, operation parameters, imports and composite owner classes
#include "CityModel/Person.hpp"

//Packges and Factories included from types of attributes, operation parameters, imports and composite owner classes

//Packages of included Enumerations

//Includes of PluginFramework (if required)

//Includes of OpaqueBevaiors (if required)
//Included from operation "addResident"
#include "CityModel/Person.hpp"
//Included from operation "removeResident"
#include "CityModel/Person.hpp"

//Includes from InstanceValues (if required)

//Includes from Ports typed by interfaces (if required)

//Includes from roles of ConnectorEnds (if required)

using namespace CityModel;

//*********************************
// Constructor / Destructor
//*********************************
ResidentialBuildingImpl::ResidentialBuildingImpl()
{
	/*
	NOTE: Due to virtual inheritance, base class constrcutors may not be called correctly
	*/
	DEBUG_MESSAGE(std::cout<<"ResidentialBuilding is created..."<<std::endl;)
	//***********************************
	// init Get Set
	//getter init
		//Property inhabitants
		m_getterMap.insert(std::pair<long long,std::function<Any()>>(262034712,[this](){ return eAny(this->getInhabitants());}));
	
	
	
	//unsetter init
		//Property inhabitants
		m_unsetterMap.insert(std::pair<long long,std::function<void()>>(262034712,[this](){m_inhabitants->clear();}));
	
	
	//invocation init
		//Operation addResident
		m_invocationMap.insert(std::pair<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>(1105068038, [this](std::shared_ptr<Bag<Any>> arguments) {
			//Retrieve input parameter 'person'
			Any anyPerson = *(arguments->at(0).get());
			std::shared_ptr<CityModel::Person> person = anyPerson->get<std::shared_ptr<CityModel::Person>>();
	
			this->addResident(person);
			return eAny(nullptr);
		}));
		//Operation removeResident
		m_invocationMap.insert(std::pair<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>(384374853, [this](std::shared_ptr<Bag<Any>> arguments) {
			//Retrieve input parameter 'person'
			Any anyPerson = *(arguments->at(0).get());
			std::shared_ptr<CityModel::Person> person = anyPerson->get<std::shared_ptr<CityModel::Person>>();
	
			this->removeResident(person);
			return eAny(nullptr);
		}));
	
}


ResidentialBuildingImpl::~ResidentialBuildingImpl()
{
	DEBUG_MESSAGE(std::cout<<"ResidentialBuilding is destroyed..."<<std::endl;)
}

ResidentialBuildingImpl::ResidentialBuildingImpl(const ResidentialBuildingImpl & obj):ResidentialBuildingImpl()
{
	*this = obj;
}

std::shared_ptr<ecore::EObject>  ResidentialBuildingImpl::copy() const
{
	std::shared_ptr<ResidentialBuildingImpl> element(new ResidentialBuildingImpl());
	*element=(*this);
	element->setThisResidentialBuildingPtr(element);
	return element;
}

ResidentialBuildingImpl& ResidentialBuildingImpl::operator=(const ResidentialBuildingImpl & obj)
{
	//call overloaded =Operator for each base class
	BuildingImpl::operator=(obj);
	//create copy of all Attributes
	#ifdef SHOW_COPIES
	std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\r\ncopy ResidentialBuilding "<< this << "\r\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ " << std::endl;
	#endif
	instantiate();

	//copy attributes with no containment (soft copy)
	m_inhabitants = obj.getInhabitants();

	//clone attributes with containment (deep copy)

	return *this;
}


std::shared_ptr<uml::Class> ResidentialBuildingImpl::getMetaClass()
{
	return CityModelPackageImpl::eInstance()->get_CityModel_ResidentialBuilding();
}

void ResidentialBuildingImpl::instantiate()
{   
	BuildingImpl::instantiate();
	
}

void ResidentialBuildingImpl::destroy()
{	

	//Erase properties
	//deleting property inhabitants
	m_inhabitants->clear();
	
	//Erase back reference to owner
}

//*********************************
// Attribute Setter Getter
//*********************************

std::shared_ptr<Bag<CityModel::Person>> ResidentialBuildingImpl::getInhabitants() const 
{
	if(m_inhabitants == nullptr)
	{
		m_inhabitants.reset(new Bag<CityModel::Person>());
		
	}

	return m_inhabitants;
}

//*********************************
// Union Getter
//*********************************



//*********************************
// Operations
//*********************************
void ResidentialBuildingImpl::addResident(std::shared_ptr<CityModel::Person> person) 
{

	// Implemented as Opaque behaviour addResident

m_inhabitants -> add(person);

}

void ResidentialBuildingImpl::removeResident(std::shared_ptr<CityModel::Person> person) 
{

	// Implemented as Opaque behaviour removeResident

m_inhabitants -> erase(person);

}

//*********************************
// Structural Feature Getter/Setter
//*********************************
//Get
Any ResidentialBuildingImpl::get(std::shared_ptr<uml::Property> _property) const
{
	std::string qualifiedName = _property->getQualifiedName();
    return this->get(qualifiedName);
}

Any ResidentialBuildingImpl::get(std::string _qualifiedName) const
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    return this->get(uID);
}

Any ResidentialBuildingImpl::get(long long _uID) const
{
	std::map<long long, std::function<Any()>>::const_iterator iter = m_getterMap.find(_uID);
    if(iter != m_getterMap.cend())
    {
        //invoke the getter function
        return iter->second();
    }

	Any result;
	result = CityModel::BuildingImpl::get(_uID);
	if (result != nullptr)
	{
		return result;
	}
	return result;
}

//Set
void ResidentialBuildingImpl::set(std::shared_ptr<uml::Property> _property, Any value)
{
	std::string qualifiedName = _property->getQualifiedName();
    this->set(qualifiedName, value);
}

void ResidentialBuildingImpl::set(std::string _qualifiedName, Any value)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    this->set(uID, value);
}

void ResidentialBuildingImpl::set(long long _uID, Any value)
{
	std::map<long long, std::function<void(Any)>>::const_iterator iter = m_setterMap.find(_uID);
    if(iter != m_setterMap.cend())
    {
        //invoke the setter function
        iter->second(value);
    }
	CityModel::BuildingImpl::set(_uID, value);
}

//Unset
void ResidentialBuildingImpl::unset(std::shared_ptr<uml::Property> _property)
{
	std::string qualifiedName = _property->getQualifiedName();
    this->unset(qualifiedName);
}

void ResidentialBuildingImpl::unset(std::string _qualifiedName)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    this->unset(uID);
}

void ResidentialBuildingImpl::unset(long long _uID)
{
	std::map<long long, std::function<void()>>::const_iterator iter = m_unsetterMap.find(_uID);
    if(iter != m_unsetterMap.cend())
    {
        //invoke the unsetter function
        iter->second();
    }
	CityModel::BuildingImpl::unset(_uID);
}


//*********************************
// Operation Invoction
//*********************************
//Invoke
Any ResidentialBuildingImpl::invoke(std::shared_ptr<uml::Operation> _operation, std::shared_ptr<Bag<Any>> _arguments)
{
	std::string qualifiedName = _operation->getQualifiedName();

	for(unsigned int i = 0; i < _operation->getOwnedParameter()->size(); i++)
	{
		qualifiedName += "_" + _operation->getOwnedParameter()->at(i)->getType()->getName();
	}

    return this->invoke(qualifiedName, _arguments);
}

Any ResidentialBuildingImpl::invoke(std::string _qualifiedName, std::shared_ptr<Bag<Any>> _arguments)
{
	long long uID = util::Util::polynomialRollingHash(_qualifiedName);
    return this->invoke(uID, _arguments);
}

Any ResidentialBuildingImpl::invoke(long long _uID, std::shared_ptr<Bag<Any>> _arguments)
{
	std::map<long long, std::function<Any(std::shared_ptr<Bag<Any>>)>>::const_iterator iter = m_invocationMap.find(_uID);
    if(iter != m_invocationMap.cend())
    {
        //invoke the operation
        return iter->second(_arguments);
    }
	
	Any result;
	result = CityModel::BuildingImpl::invoke(_uID, _arguments);
	if (result != nullptr)
	{
		return result;
	}
	return result;
}

std::shared_ptr<ResidentialBuilding> ResidentialBuildingImpl::getThisResidentialBuildingPtr()
{
	return m_thisResidentialBuildingPtr.lock();
}
void ResidentialBuildingImpl::setThisResidentialBuildingPtr(std::weak_ptr<ResidentialBuilding> thisResidentialBuildingPtr)
{
	m_thisResidentialBuildingPtr = thisResidentialBuildingPtr;
	setThisBuildingPtr(thisResidentialBuildingPtr);
}
